HttpJspBase (Apache Tomcat 10.1.57 API Documentation)
Description: declaration: package: org.apache.jasper.runtime, class: HttpJspBase

# Class HttpJspBase

java.lang.Object
jakarta.servlet.GenericServlet
jakarta.servlet.http.HttpServlet
org.apache.jasper.runtime.HttpJspBase

All Implemented Interfaces:
  `HttpJspPage, JspPage, Servlet, ServletConfig, Serializable`

public abstract class HttpJspBase extends HttpServlet implements HttpJspPage
This is the super class of all JSP-generated servlets.

See Also:
  - Serialized Form

- ## Field Summary

  ### Fields inherited from class HttpServlet

  `LEGACY_DO_HEAD`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `HttpJspBase()`
  Creates a new instance of an HTTP JSP servlet.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `_jspDestroy()`
  Sub-classes may override this method to perform cleanup.
  `void`
  `_jspInit()`
  Sub-classes may override this method to perform initialization.
  `abstract void`
  `_jspService(HttpServletRequest request, HttpServletResponse response)`
  The _jspService()method corresponds to the body of the JSP page.
  `final void`
  `destroy()`
  Called by the servlet container to indicate to a servlet that the servlet is being taken out of service.
  `String`
  `getServletInfo()`
  Returns information about the servlet, such as author, version, and copyright.
  `final void`
  `init(ServletConfig config)`
  Called by the servlet container to indicate to a servlet that the servlet is being placed into service.
  `void`
  `jspDestroy()`
  The jspDestroy() method is invoked when the JSP page is about to be destroyed.
  `void`
  `jspInit()`
  The jspInit() method is invoked when the JSP page is initialized.
  `final void`
  `service(HttpServletRequest request, HttpServletResponse response)`
  Receives standard HTTP requests from the public `service` method and dispatches them to the `do`Method methods defined in this class.

  ### Methods inherited from class HttpServlet

  `doDelete, doGet, doHead, doOptions, doPost, doPut, doTrace, getLastModified, service`

  ### Methods inherited from class GenericServlet

  `getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletName, init, log, log`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface Servlet

  `getServletConfig, service`

- ## Constructor Details

  - ### HttpJspBase

    protected HttpJspBase()
    Creates a new instance of an HTTP JSP servlet.

- ## Method Details

  - ### init

    public final void init(ServletConfig config) throws ServletException
    Description copied from class: `jakarta.servlet.GenericServlet`
    Called by the servlet container to indicate to a servlet that the servlet is being placed into service. See `Servlet.init(ServletConfig)`.

    This implementation stores the `ServletConfig` object it receives from the servlet container for later use. When overriding this form of the method, call `super.init(config)`.

    Specified by:
      `init` in interface `Servlet`
    Overrides:
      `init` in class `HttpServlet`
    Parameters:
      `config` - the `ServletConfig` object that contains configuration information for this servlet
    Throws:
      `ServletException` - if an exception occurs that interrupts the servlet's normal operation
    See Also:
      - `UnavailableException`

  - ### getServletInfo

    public String getServletInfo()
    Description copied from class: `jakarta.servlet.GenericServlet`
    Returns information about the servlet, such as author, version, and copyright. By default, this method returns an empty string. Override this method to have it return a meaningful value. See `Servlet.getServletInfo()`.
    Specified by:
      `getServletInfo` in interface `Servlet`
    Overrides:
      `getServletInfo` in class `GenericServlet`
    Returns:
      String information about this servlet, by default an empty string

  - ### destroy

    public final void destroy()
    Description copied from class: `jakarta.servlet.GenericServlet`
    Called by the servlet container to indicate to a servlet that the servlet is being taken out of service. See `Servlet.destroy()`.
    Specified by:
      `destroy` in interface `Servlet`
    Overrides:
      `destroy` in class `GenericServlet`

  - ### service

    public final void service(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    Description copied from class: `jakarta.servlet.http.HttpServlet`
    Receives standard HTTP requests from the public `service` method and dispatches them to the `do`Method methods defined in this class. This method is an HTTP-specific version of the `Servlet.service(ServletRequest, ServletResponse)` method. There's no need to override this method.
    Overrides:
      `service` in class `HttpServlet`
    Parameters:
      `request` - the `HttpServletRequest` object that contains the request the client made of the servlet
      `response` - the `HttpServletResponse` object that contains the response the servlet returns to the client
    Throws:
      `ServletException` - if the HTTP request cannot be handled
      `IOException` - if an input or output error occurs while the servlet is handling the HTTP request
    See Also:
      - `Servlet.service(ServletRequest, ServletResponse)`

  - ### jspInit

    public void jspInit()
    Description copied from interface: `jakarta.servlet.jsp.JspPage`
    The jspInit() method is invoked when the JSP page is initialized. It is the responsibility of the JSP implementation (and of the class mentioned by the extends attribute, if present) that at this point invocations to the getServletConfig() method will return the desired value.

    A JSP page can override this method by including a definition for it in a declaration element.

    A JSP page should redefine the init() method from Servlet.

    Specified by:
      `jspInit` in interface `JspPage`

  - ### _jspInit

    public void _jspInit()
    Sub-classes may override this method to perform initialization. Called from `init(jakarta.servlet.ServletConfig)`.

  - ### jspDestroy

    public void jspDestroy()
    Description copied from interface: `jakarta.servlet.jsp.JspPage`
    The jspDestroy() method is invoked when the JSP page is about to be destroyed.

    A JSP page can override this method by including a definition for it in a declaration element.

    A JSP page should redefine the destroy() method from Servlet.

    Specified by:
      `jspDestroy` in interface `JspPage`

  - ### _jspDestroy

    protected void _jspDestroy()
    Sub-classes may override this method to perform cleanup. Called from `destroy()`.

  - ### _jspService

    public abstract void _jspService(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    Description copied from interface: `jakarta.servlet.jsp.HttpJspPage`
    The _jspService()method corresponds to the body of the JSP page. This method is defined automatically by the JSP container and should never be defined by the JSP page author.

    If a superclass is specified using the extends attribute, that superclass may choose to perform some actions in its service() method before or after calling the _jspService() method. See using the extends attribute in the JSP_Engine chapter of the JSP specification.

    Specified by:
      `_jspService` in interface `HttpJspPage`
    Parameters:
      `request` - Provides client request information to the JSP.
      `response` - Assists the JSP in sending a response to the client.
    Throws:
      `ServletException` - Thrown if an error occurred during the processing of the JSP and that the container should take appropriate action to clean up the request.
      `IOException` - Thrown if an error occurred while writing the response for this page.